﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace ActivationWork
{
    public partial class Form1 : Form
    {
        DataSet dataSet;
        Boolean activeChildRow;
        DataTable dataTable;
        int rowIndex;
        int cellIndex;
        int childIndex;

        public Form1()
        {
            InitializeComponent();
            this.StartPosition = FormStartPosition.CenterScreen;
            this.Text = "Activation Work";
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            activeChildRow = false;
            rowIndex = 0;
            cellIndex = 0;
            PopulateFirstDataSet();
            ultraGrid1.DataSource = dataSet;
            ultraGrid1.Rows.ExpandAll(true);
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.GroupByBox.Hidden = true;
        }

        private void PopulateFirstDataSet()
        {
            dataSet = new DataSet();
            dataTable = new DataTable("Customer");
            dataTable.Columns.Add("CustomerID", typeof(int));
            dataTable.Columns.Add("CustomerName", typeof(string));
            dataTable.Columns.Add("Date", typeof(DateTime));
            dataTable.Columns.Add("City", typeof(string));
            dataTable.Columns.Add("State", typeof(string));

            dataTable.Rows.Add(new object[] { 1, "John Lever", DateTime.Now, "New York", "NY" });
            dataTable.Rows.Add(new object[] { 2, "Walter Smith", DateTime.Now.AddDays(1), "Jersey City", "NJ" });
            dataTable.Rows.Add(new object[] { 3, "Kathy Lever", DateTime.Now.AddDays(2), "Newark", "DE" });
            dataTable.Rows.Add(new object[] { 4, "George Wills", DateTime.Now.AddDays(3), "Trenton", "NJ" });

            dataSet.Tables.Add(dataTable);

            dataTable = new DataTable("Orders");
            dataTable.Columns.Add("OrderID", typeof(int));
            dataTable.Columns.Add("ProductName", typeof(string));
            dataTable.Columns.Add("Price", typeof(double));
            dataTable.Columns.Add("Quantity", typeof(int));
            dataTable.Columns.Add("Color", typeof(string));
            dataTable.Rows.Add(new object[] { 1, "Bolts", 2.30, 15, "" });
            dataTable.Rows.Add(new object[] { 1, "Screws", 2.03, 55, "" });
            dataTable.Rows.Add(new object[] { 1, "Nails", 1.01, 25, "" });
            dataTable.Rows.Add(new object[] { 2, "Bolts", 2.30, 65, "" });
            dataTable.Rows.Add(new object[] { 2, "Screws", 2.03, 75, "" });
            dataTable.Rows.Add(new object[] { 2, "Nails", 1.01, 95, "" });
            dataTable.Rows.Add(new object[] { 3, "Bolts", 2.30, 65, "" });
            dataTable.Rows.Add(new object[] { 3, "Screws", 2.03, 205, "" });
            dataTable.Rows.Add(new object[] { 3, "Nails", 1.01, 265, "" });
            dataTable.Rows.Add(new object[] { 4, "Bolts", 2.30, 695, "" });
            dataSet.Tables.Add(dataTable);

            dataSet.Relations.Add("Customer_Order", dataSet.Tables["Customer"].Columns["CustomerID"],
            dataSet.Tables["Orders"].Columns["OrderID"]);
        }

        private void PopulateSecondDataSet()
        {
            dataSet = new DataSet();
            dataTable = new DataTable("Customer");
            dataTable.Columns.Add("CustomerID", typeof(int));
            dataTable.Columns.Add("CustomerName", typeof(string));
            dataTable.Columns.Add("Date", typeof(DateTime));
            dataTable.Columns.Add("City", typeof(string));
            dataTable.Columns.Add("State", typeof(string));

            dataTable.Rows.Add(new object[] { 1, "Bill Monroe", DateTime.Now, "Baltimore", "MD" });
            dataTable.Rows.Add(new object[] { 2, "John Hartford", DateTime.Now.AddDays(4), "Wilmington", "DE" });
            dataTable.Rows.Add(new object[] { 3, "Ricky Scaggs", DateTime.Now.AddDays(5), "Philadelphia", "PA" });
            dataTable.Rows.Add(new object[] { 4, "Doc Watson", DateTime.Now.AddDays(6), "Washington", "DC" });

            dataSet.Tables.Add(dataTable);

            dataTable = new DataTable("Orders");
            dataTable.Columns.Add("OrderID", typeof(int));
            dataTable.Columns.Add("ProductName", typeof(string));
            dataTable.Columns.Add("Price", typeof(double));
            dataTable.Columns.Add("Quantity", typeof(int));
            dataTable.Columns.Add("Color", typeof(string));
            dataTable.Rows.Add(new object[] { 1, "Bolts", 2.30, 15, "" });
            dataTable.Rows.Add(new object[] { 1, "Screws", 2.03, 55, "" });
            dataTable.Rows.Add(new object[] { 1, "Nails", 1.01, 25, "" });
            dataTable.Rows.Add(new object[] { 2, "Bolts", 2.30, 65, "" });
            dataTable.Rows.Add(new object[] { 2, "Screws", 2.03, 75, "" });
            dataTable.Rows.Add(new object[] { 2, "Nails", 1.01, 95, "" });
            dataTable.Rows.Add(new object[] { 3, "Bolts", 2.30, 65, "" });
            dataTable.Rows.Add(new object[] { 3, "Screws", 2.03, 205, "" });
            dataTable.Rows.Add(new object[] { 3, "Nails", 1.01, 265, "" });
            dataTable.Rows.Add(new object[] { 4, "Bolts", 2.30, 695, "" });
            dataSet.Tables.Add(dataTable);

            dataSet.Relations.Add("Customer_Order", dataSet.Tables["Customer"].Columns["CustomerID"],
            dataSet.Tables["Orders"].Columns["OrderID"]);
        }

        private void ultraGrid1_AfterCellActivate(object sender, EventArgs e)
        {
            if (ultraGrid1.ActiveCell.Band.Index == 0)
            {
                rowIndex = ultraGrid1.ActiveCell.Row.Index;
                cellIndex = ultraGrid1.ActiveCell.Column.Index;
            }
            else
            {
                activeChildRow = true;
                rowIndex = ultraGrid1.ActiveCell.Row.ParentRow.Index;
                cellIndex = ultraGrid1.ActiveCell.Column.Index;
                childIndex = ultraGrid1.ActiveCell.Row.Index;
            }
        }

        private void reassignButton_Click(object sender, EventArgs e)
        {
            PopulateSecondDataSet();
            ultraGrid1.DataSource = dataSet;
            ultraGrid1.Rows.ExpandAll(true);
            if (activeChildRow)
            {
                ultraGrid1.ActiveCell = ultraGrid1.Rows[rowIndex].ChildBands[0].Rows[childIndex].Cells[cellIndex];
            }
            else
            {
                ultraGrid1.ActiveCell = ultraGrid1.Rows[rowIndex].Cells[cellIndex];
            }
            ultraGrid1.PerformAction(UltraGridAction.ActivateCell);
            reassignButton.Enabled = false;
        }
    }
}
